<?php

namespace Service;


class Exception extends \Exception{


    const LABEL_ERROR_API = [
        "ACCESS_PROFILE_EMPTY" => "Operador selecionado não possui perfil de acesso para essa fonte de dados",
        "OPERATOR_INACTIVE" => "Operador selecionado para a fonte de dados se encontra inativo",
        "ORGANIZATION_INACTIVE" => "Coleta bloqueada! Organização se encontra inativa",
        "STRUCTURE_NOT_FOUND_IN_DB" => "Operador selecionado não se encontra relacionado a nenhuma estrutura",
        "API_USE_TIME_NOT_ALLOWED" => "Tentativa de coleta fora do horário permitido (__I__ a __E__) para intervalos maiores que __D__ dias",
        "API_USAGE_AMOUNT_EXCEEDED" => "Tentativa de coleta fora da quantidade limite permitida para o dia (__D__ Coletas)",
        "API_REQUEST_DUPLICATE" => "Coleta bloqueada! Não é permitido fazer várias coletas de dados ao mesmo tempo",
        "TIME_OUT" => "Coleta não realizada. Servidor sobrecarregado no momento da solicitação",
        "API_PERIOD_TOO_BIG"=> "Coleta bloqueada! Período solicitado maior que o intervalo permitido (__D__ Dias).",
        "MANUAL_STOP"=> "Coleta Parada manualmente! Coleta para pelo operador __O__ as __H__",
    ];

    public static function buildErrorJSON(string $message, array $params = []){
        $error = array();
        $error["message"] = $message;
        if(!empty($params)){
            $error["params"] = $params;
        }
        return json_encode($error);
    }

    public static function connectionNotFound() {
        return new static("Connection not found");
    }

    public static function clientIdNotFound() {
        throw new \Exception("CLIENT_ID_NOT_FOUND",1);
    }

    public static function clientSecretNotFound() {
        throw new \Exception("CLIENT_SECRET_NOT_FOUND",2);
    }

    public static function apiIdNotFound() {
        throw new \Exception("API_ID_NOT_FOUND",3);
    }

    public static function pageNotFound() {
        throw new \Exception("PAGE_NOT_FOUND",4);
    }

    public static function fieldDateNameNotFound() {
        throw new \Exception("FIELD_DATE_NAME_NOT_FOUND",5);
    }

    public static function fieldDateStartNotFound() {
        throw new \Exception("FIELD_DATE_START_NOT_FOUND",6);
    }

    public static function fieldDateEndNotFound() {
        throw new \Exception("FIELD_DATE_END_NOT_FOUND",7);
    }

    public static function filterNameNotFound() {
        throw new \Exception("FILTER|FIELD_DATE|NAME_NOT_FOUND",8);
    }

    public static function filterStartNotFound() {
        throw new \Exception("FILTER|FIELD_DATE|START_NOT_FOUND",9);
    }

    public static function filterEndNotFound() {
        throw new \Exception("FILTER|FIELD_DATE|END_NOT_FOUND",10);
    }

    public static function filterEndNotCorrectFormat() {
        throw new \Exception("FILTER|FIELD_DATE|END_NOT_CORRECT_FORMAT",11);
    }

    public static function filterStartNotCorrectFormat() {
        throw new \Exception("FILTER|FIELD_DATE|START_NOT_CORRECT_FORMAT",12);
    }

    public static function structureNotFoundINDb() {
        throw new \Exception("STRUCTURE_NOT_FOUND_IN_DB",13);
    }
    public static function dataSourceNotFoundINDb() {
        throw new \Exception("API_ID_NOT_FOUND_IN_DB",14);
    }
    public static function webTokenInvalid() {
        throw new \Exception("WEB_TOKEN_INVALID",15);
    }

    public static function accessProfileEmpty() {
        throw new \Exception("ACCESS_PROFILE_EMPTY",16);
    }

    public static function operatorInactive() {
        throw new \Exception("OPERATOR_INACTIVE",17);
    }

    public static function organizationInactive() {
        throw new \Exception("ORGANIZATION_INACTIVE",18);
    }

    public static function tempWebTokenInvalid() {
        throw new \Exception("TEMP_WEB_TOKEN_INVALID",19);
    }

} 