<?php
namespace Service;

use Zeedhi\Framework\DataSource\FilterCriteria;
use \Service\Manager\Mongo\Manager;

class ViewProperty {

    protected $dataSourceName = 'viewProperty';
    /** @var \Service\Manager\Mongo\Manager $mongoManager */
    protected $mongoManager;

    public function __construct(Manager $mongoManager) {
        $this->mongoManager = $mongoManager;
    }

    public function findBy(FilterCriteria $filterCriteria) {
        return $this->mongoManager->findBy($filterCriteria)->getRows();
    }

    public function findAll() {
        return $this->findBy(new FilterCriteria($this->dataSourceName));
    }

    public function findById($id) {
        $viewProperty = $this->findByIds(array($id));
        return count($viewProperty) > 0 ? $viewProperty[0] : null;
    }

    public function findByIds(array $ids) {
        $filterCriteria = new FilterCriteria($this->dataSourceName, array(array("columnName"=>"_id", "value" => $ids, "operator" => FilterCriteria::IN)));
        return $this->mongoManager->findBy($filterCriteria)->getRows();
    }

}