/*-------------------------------------------------------------------------------------------------------------+
|                                                       					|
|   Trigger: CTRL_FILIAL                     					|
|   Tabela: Filial		           					|
|                                                       					|
|   Descrio:							|
|   Atualiza os dados da HISTFILIAL quando os campos QTFUNCFILI,	|
|   CDGOPERAC OU CDSUPERVISOR so alterados.			|
|								|
|   Criao:                                       					|
|   18/01/2008 - Luiz Passos               					|
|                                                       					|
+-------------------------------------------------------------------------------------------------------------*/
create or replace TRIGGER CTRL_FILIAL
AFTER INSERT OR UPDATE OR DELETE
ON FILIAL FOR EACH ROW

DECLARE
   V_DTREFERENCIA DATE;

BEGIN

  IF DELETING THEN 
    DELETE FROM HISTFILIAL WHERE CDFILIAL = :OLD.CDFILIAL;
  END IF;
  
  IF INSERTING THEN
    INSERT INTO HISTFILIAL
      (CDFILIAL, 	
      DTREFEHIST,
      QTFUNCFILIHIST, 
      CDGOPERACHIST,
      CDSUPERVHIST)
    VALUES
      (:NEW.CDFILIAL,
      TO_DATE('01'||TO_CHAR(SYSDATE,'MMYYYY'),'DDMMYYYY'),
      :NEW.QTFUNCFILI,
      :NEW.CDGOPERAC,
      :NEW.CDSUPERVISOR);
  END IF;
  
  IF UPDATING THEN   
    IF (NVL(:OLD.CDFILIAL,''))      <> (NVL(:NEW.CDFILIAL,''))    OR       
       (NVL(:OLD.QTFUNCFILI,0))    <> (NVL(:NEW.QTFUNCFILI,0))    OR
       (NVL(:OLD.CDGOPERAC,0))     <> (NVL(:NEW.CDGOPERAC,0))     OR
       (NVL(:OLD.CDSUPERVISOR,0))  <> (NVL(:NEW.CDSUPERVISOR,0))  THEN

      BEGIN
        SELECT DTREFEHIST INTO V_DTREFERENCIA FROM HISTFILIAL WHERE TO_CHAR(DTREFEHIST, 'MMYYYY') = TO_CHAR(SYSDATE,'MMYYYY') AND CDFILIAL = :NEW.CDFILIAL;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
        V_DTREFERENCIA := NULL;
      END;           

      IF V_DTREFERENCIA IS NULL THEN 
          INSERT INTO HISTFILIAL
            (CDFILIAL, 	
            DTREFEHIST,
            QTFUNCFILIHIST, 
            CDGOPERACHIST,
            CDSUPERVHIST)
          VALUES
            (:NEW.CDFILIAL,
            TO_DATE('01'||TO_CHAR(SYSDATE,'MMYYYY'),'DDMMYYYY'),
            :NEW.QTFUNCFILI,
            :NEW.CDGOPERAC,
            :NEW.CDSUPERVISOR);          
      ELSE
        UPDATE HISTFILIAL SET
          QTFUNCFILIHIST = :NEW.QTFUNCFILI,
          CDGOPERACHIST  = :NEW.CDGOPERAC,
          CDSUPERVHIST   = :NEW.CDSUPERVISOR
        WHERE
          CDFILIAL  = :OLD.CDFILIAL AND
          TO_CHAR(DTREFEHIST,'MMYYYY') = TO_CHAR(SYSDATE,'MMYYYY');
      END IF;
    END IF;  
  END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CTRL_FILIAL','5.01.005'); END;
/
